/************************************************************************************
 
   ██████╗ ██████╗ ███╗   ██╗████████╗██████╗  ██████╗ ██╗     ██╗     ███████╗██████╗ 
  ██╔════╝██╔═══██╗████╗  ██║╚══██╔══╝██╔══██╗██╔═══██╗██║     ██║     ██╔════╝██╔══██╗
  ██║     ██║   ██║██╔██╗ ██║   ██║   ██████╔╝██║   ██║██║     ██║     █████╗  ██████╔╝
  ██║     ██║   ██║██║╚██╗██║   ██║   ██╔══██╗██║   ██║██║     ██║     ██╔══╝  ██╔══██╗
  ╚██████╗╚██████╔╝██║ ╚████║   ██║   ██║  ██║╚██████╔╝███████╗███████╗███████╗██║  ██║
   ╚═════╝ ╚═════╝ ╚═╝  ╚═══╝   ╚═╝   ╚═╝  ╚═╝ ╚═════╝ ╚══════╝╚══════╝╚══════╝╚═╝  ╚═╝
   
   Dans cette page sont rangées toutes les fonctions permettant à l'utilisateur
   d'interagir avec le programme avec un controlleur préalablement paramétré

*************************************************************************************/



import themidibus.*; 
MidiBus midibus; 



void midiInit() {
  
  /* cette fonction initialise le controleur */
  
  MidiBus.list();
  midibus = new MidiBus(this, 0, -1);
}



void noteOn(int channel, int pitch, int velocity) {
  
  /* cette fonction est lue lorsqu'un signal est envoyé par le controleur,
  les valeurs du programe sont alors modifiées en conséquence */
  
  if (pitch==14) cntrlInt[2]--; // flèche de gauche
  if (pitch==13) cntrlInt[2]++; // flèche de droite
  if (cntrlInt[2]>cntrlMax[2]) cntrlInt[2]=0;
  if (cntrlInt[2]<0) cntrlInt[2]=cntrlMax[2];
  setColor(cntrlInt[2]);
}



void controllerChange(int channel, int number, int value) {  
  
  /* cette fonction est lue lorsque la valeur d'un slideur,
  les valeurs du programe sont alors modifiées en conséquence */

  if (number==0)  changeCamera(cntrlInt[3]);
  if (number==1)  cntrlInt[0]=value;
  if (number==2)  cntrlInt[1]=value;
  if (number==3)  cntrlFloat[2]=float(value)/3-0.001;
  if (number==4)  cntrlFloat[1]=float(value)/126;
  if (number==5)  cntrlFloat[0]=float(value)/126;
  if (number==6)  cntrlFloat[3]=1-(float(value)/126);
  if (number==7)  postprocessing[0]=!postprocessing[0];
  if (number==8)  postprocessing[5]=!postprocessing[5];
  if (number==9)  postprocessing[3]=!postprocessing[3];
  if (number==10) postprocessing[4]=!postprocessing[4];
  if (number==11) postprocessing[2]=!postprocessing[2];
  if (number==12) postprocessing[1]=!postprocessing[1];
  
  if (number==0)  changeCamera(cntrlInt[3]);
  else            shaderSettings();
  
}
