#ifdef GL_ES
precision mediump float;
precision mediump int;
#endif

#define PROCESSING_TEXTURE_SHADER

uniform sampler2D texture;
uniform vec2 texOffset;
uniform vec2 texOffset2;


varying vec4 vertColor;
varying vec4 vertTexCoord;

void main(void) {
  // Grouping texcoord variables in order to make it work in the GMA 950. See post #13
  // in this thread:
  // http://www.idevgames.com/forums/thread-3467.html
  vec2 texOffset2 = vec2(0.0005,0.0005);

  // attribution de toutes les coordonnées
  vec2 tc0 = vertTexCoord.st + vec2(-texOffset2.s, -texOffset2.t);
  vec2 tc1 = vertTexCoord.st + vec2(          0.0, -texOffset2.t);
  vec2 tc2 = vertTexCoord.st + vec2(+texOffset2.s, -texOffset2.t);
  vec2 tc3 = vertTexCoord.st + vec2(-texOffset2.s,           0.0);
  vec2 tc4 = vertTexCoord.st + vec2(          0.0,           0.0);
  vec2 tc5 = vertTexCoord.st + vec2(+texOffset2.s,           0.0);
  vec2 tc6 = vertTexCoord.st + vec2(-texOffset2.s, +texOffset2.t);
  vec2 tc7 = vertTexCoord.st + vec2(          0.0, +texOffset2.t);
  vec2 tc8 = vertTexCoord.st + vec2(+texOffset2.s, +texOffset2.t);
  
  // couleurs pas coorconées
  vec4 col0 = texture2D(texture, tc0);
  vec4 col1 = texture2D(texture, tc1);
  vec4 col2 = texture2D(texture, tc2);
  vec4 col3 = texture2D(texture, tc3);
  vec4 col4 = texture2D(texture, tc4);
  vec4 col5 = texture2D(texture, tc5);
  vec4 col6 = texture2D(texture, tc6);
  vec4 col7 = texture2D(texture, tc7);
  vec4 col8 = texture2D(texture, tc8);

  // moyenne des couleurs
  float t = col0.w + col1.w  + col2.w  + col3.w  + col4.w  + col5.w  + col6.w  + col7.w  + col8.w ;

  vec4 sum = (col0*col0.w + col1*col1.w + col2*col2.w + col3*col3.w + col4*col4.w + col5*col5.w + col6*col6.w + col7*col7.w + col8*col8.w) / t;  

  sum.w = t/9.0;

  gl_FragColor = sum;  
}
