#ifdef GL_ES
precision mediump float;
precision mediump int;
#endif

#define PROCESSING_TEXTURE_SHADER

uniform sampler2D texture;
uniform float vel;
// change these values to 0.0 to turn off individual effects

varying vec4 vertColor;
varying vec4 vertTexCoord;

void main(void){

	vec2 uv =  vertTexCoord.st;
	
	float red 	=   texture(	texture, 	vec2(uv.x -0.01*vel,uv.y)).r;
	float green = 	texture(	texture, 	uv).g;
	float blue 	=	  texture(	texture, 	vec2(uv.x +0.01*vel,uv.y)).b;
	
	vec3 color = vec3(red,green,blue);
	float scanline = sin(uv.y*800.0)*0.04;
	
	gl_FragColor = vec4(color,1.0);
}
