#ifdef GL_ES
precision mediump float;
precision mediump int;
#endif

#define PROCESSING_TEXTURE_SHADER

uniform sampler2D texture;
uniform float ray;


varying vec4 vertColor;
varying vec4 vertTexCoord;

void main(void) {
  // Grouping texcoord variables in order to make it work in the GMA 950. See post #13
  // in this thread:
  // http://www.idevgames.com/forums/thread-3467.html
  vec2 texOffset2 = vec2(0.001,0.001);
  
  vec2 tc0   = vertTexCoord.st + vec2(   -ray,   -ray);
  vec2 tc1   = vertTexCoord.st + vec2(    0.0,   -ray);
  vec2 tc2   = vertTexCoord.st + vec2(   +ray,   -ray);
  vec2 tc3   = vertTexCoord.st + vec2(   -ray,    0.0);
  vec2 tc4   = vertTexCoord.st + vec2(    0.0,    0.0);
  vec2 tc5   = vertTexCoord.st + vec2(   +ray,    0.0);
  vec2 tc6   = vertTexCoord.st + vec2(   -ray,   +ray);
  vec2 tc7   = vertTexCoord.st + vec2(    0.0,   +ray);
  vec2 tc8   = vertTexCoord.st + vec2(   +ray,   +ray);
  vec2 tc9   = vertTexCoord.st + vec2( -ray*2, -ray*2);
  vec2 tc10  = vertTexCoord.st + vec2(    0.0, -ray*2);
  vec2 tc11  = vertTexCoord.st + vec2( +ray*2, -ray*2);
  vec2 tc12  = vertTexCoord.st + vec2( -ray*2,    0.0);
  vec2 tc13  = vertTexCoord.st + vec2( +ray*2,    0.0);
  vec2 tc14  = vertTexCoord.st + vec2( -ray*2, +ray*2);
  vec2 tc15  = vertTexCoord.st + vec2(    0.0, +ray*2);
  vec2 tc16  = vertTexCoord.st + vec2( +ray*2, +ray*2);
  vec2 tc17  = vertTexCoord.st + vec2( -ray*1, +ray*2);
  vec2 tc18  = vertTexCoord.st + vec2( -ray*2, +ray*1);
  vec2 tc19  = vertTexCoord.st + vec2( +ray*1, -ray*2);
  vec2 tc20  = vertTexCoord.st + vec2( +ray*2, -ray*1);
  vec2 tc21  = vertTexCoord.st + vec2( +ray*1, +ray*2);
  vec2 tc22  = vertTexCoord.st + vec2( +ray*2, +ray*1);
  vec2 tc23  = vertTexCoord.st + vec2( -ray*1, -ray*2);
  vec2 tc24  = vertTexCoord.st + vec2( -ray*2, -ray*1);
  vec2 tc25  = vertTexCoord.st + vec2( -ray*3, -ray*3);
  vec2 tc26  = vertTexCoord.st + vec2(    0.0, -ray*3);
  vec2 tc27  = vertTexCoord.st + vec2( +ray*3, -ray*3);
  vec2 tc28  = vertTexCoord.st + vec2( -ray*3,    0.0);
  vec2 tc29  = vertTexCoord.st + vec2( +ray*3,    0.0);
  vec2 tc30  = vertTexCoord.st + vec2( -ray*3, +ray*3);
  vec2 tc31  = vertTexCoord.st + vec2(    0.0, +ray*3);
  vec2 tc32  = vertTexCoord.st + vec2( +ray*3, +ray*3);

  vec4 col0  = texture2D(texture,  tc0);
  vec4 col1  = texture2D(texture,  tc1);
  vec4 col2  = texture2D(texture,  tc2);
  vec4 col3  = texture2D(texture,  tc3);
  vec4 col4  = texture2D(texture,  tc4);
  vec4 col5  = texture2D(texture,  tc5);
  vec4 col6  = texture2D(texture,  tc6);
  vec4 col7  = texture2D(texture,  tc7);
  vec4 col8  = texture2D(texture,  tc8);
  vec4 col9  = texture2D(texture,  tc9);
  vec4 col10 = texture2D(texture, tc10);
  vec4 col11 = texture2D(texture, tc11);
  vec4 col12 = texture2D(texture, tc12);
  vec4 col13 = texture2D(texture, tc13);
  vec4 col14 = texture2D(texture, tc14);
  vec4 col15 = texture2D(texture, tc15);
  vec4 col16 = texture2D(texture, tc16);
  vec4 col17 = texture2D(texture, tc17);
  vec4 col18 = texture2D(texture, tc18);
  vec4 col19 = texture2D(texture, tc19);
  vec4 col20 = texture2D(texture, tc20);
  vec4 col21 = texture2D(texture, tc21);
  vec4 col22 = texture2D(texture, tc22);
  vec4 col23 = texture2D(texture, tc23);
  vec4 col24 = texture2D(texture, tc24);
  vec4 col25 = texture2D(texture, tc25);
  vec4 col26 = texture2D(texture, tc26);
  vec4 col27 = texture2D(texture, tc27);
  vec4 col28 = texture2D(texture, tc28);
  vec4 col29 = texture2D(texture, tc29);
  vec4 col30 = texture2D(texture, tc30);
  vec4 col31 = texture2D(texture, tc31);
  vec4 col32 = texture2D(texture, tc32);

  vec4 sum = round((col0 + col1 + col2 + col3 + col4 + col5 + col6 + col7 + col8 + col9 + col10 + col11 + col12 + col13 + col14 + col15 + col16 + col17 + col18 + col19 + col20 + col21 + col22 + col23 + col24 + col25 + col26 + col27 + col28 + col29 + col30 + col31 + col32) / 33.0);
  float op;
  if(sum.w>0.2) op=1.0;
  else op=0;

  gl_FragColor = vec4(col4.rgb,sum.w) * vertColor;        
}
