#ifdef GL_ES
precision mediump float;
precision mediump int;
#endif

#define PROCESSING_TEXTURE_SHADER

uniform sampler2D palette;
uniform vec2 texOffset;
uniform float divide;
uniform float amplitude;
uniform float inc;

varying vec4 vertColor;
varying vec4 vertTexCoord;


void main(void) {

  vec4 colorArray[5];

    colorArray[0] = texture2D(palette, vec2(0.1,0.5));
    colorArray[4] = texture2D(palette, vec2(0.3,0.5));
    colorArray[3] = texture2D(palette, vec2(0.5,0.5));
    colorArray[2] = texture2D(palette, vec2(0.7,0.5));
    colorArray[1] = texture2D(palette, vec2(0.9,0.5));
  
  vec2 tc4 = vertTexCoord.st;
  int div = int( divide * 4.0 ) + 2;
  float t = inc/4;
  float amp = 4;
  float PI = 3.1415926535897932384626433832795;
  float offset = sin(t+tc4.y*PI*8)*0.3*(amplitude-0.5);
  float m1p = mod(round(tc4.x*amp*4+offset   ),2);
  float m1n = mod(round(tc4.x*amp*4+offset+1),2);
  int m = int(mod( tc4.x*amp*div + (tc4.y+t)*amp*div*m1p - (tc4.y-t)*amp*div*m1n,div));
  gl_FragColor = colorArray[m];

 
}
