/**************************************************

  ███████╗███████╗███████╗███████╗████████╗███████╗
  ██╔════╝██╔════╝██╔════╝██╔════╝╚══██╔══╝██╔════╝
  █████╗  █████╗  █████╗  █████╗     ██║   ███████╗
  ██╔══╝  ██╔══╝  ██╔══╝  ██╔══╝     ██║   ╚════██║
  ███████╗██║     ██║     ███████╗   ██║   ███████║
  ╚══════╝╚═╝     ╚═╝     ╚══════╝   ╚═╝   ╚══════╝
  
  Dans cette page sont rangée toutes les fonctions
  relatives aux différents effets appliqué sur 
  l'image de la caméra

**************************************************/
                                  
                                                 

int strongSmooth = 4;



void clipping( PGraphics p ) {
  
  /* cette fonction détoure le rendu de la camera en
  la comparant avec l'image témoin de l'arrière plan,
  elle arondit ensuite plusieur fois le contour de 
  l'image obtenue afin notament d'éliminer d'éventuelles
  petites imperfections */
  
  int w = p.width;
  int h = p.height;
  
  clippingLayer.beginDraw();
  
  // détourage
  p.image(camera, 0, 0, w, h);
  
  
  if (greenHSB) p.filter(clippingHSB);
  else p.filter(clippingRVB);
  
  // arondissement des formes
  if (strongSmooth == 2){
    round.set("ray", 0.0016);
    p.filter(round);
  }
  if (strongSmooth >= 1){
    round.set("ray", 0.008);
    p.filter(round);
  }
  round.set("ray", 0.004);
  p.filter(round);
  round.set("ray", 0.002);
  p.filter(round);
  round.set("ray", 0.001);
  p.filter(round);
  
  // adoucissement du contour
  p.filter(smoothEdge);
  
  p.endDraw();
  shaderBgSet();
}



void bgMode(int m) {
  
  /* cette fonction apllique un effet génératif sur le calque
  bckgrndLayer en fonction des réglages de l'utilisateur, un
  effet antialiasing est ensite applique sur le calque pour
  rendre le tramage des pixels plus discret */
  
  bckgrndLayer.beginDraw();
  bckgrndLayer.clear();
  
  if      (m==0) bckgrndLayer.filter(psycho);
  else if (m==1) bckgrndLayer.filter(retro);
  else if (m==2) bckgrndLayer.filter(dotted);
  else if (m==3) bckgrndLayer.filter(zigzag);
  else if (m==4) bckgrndLayer.filter(circle);
  
  bckgrndLayer.filter(antialiasing);
  bckgrndLayer.endDraw();
}


void displayMode(int m) {
  
  /* cette fonction dispose le rendu de la camera après détourage,
  une série de configurations ont été mises en place et utilisent
  les réglages de l'utilisateur : (type de configuration, amplitude
  vitesse, et taille) */

  float a = cntrlFloat[3]*0.25;

  displayLayer.beginDraw();
  displayLayer.clear();
  displayLayer.updatePixels();
  
  if (titleScreen) {
    
    speed = 0.6;
    float w = width+width*0.5*(cntrlFloat[0]*2-1);
    
    drawImage(clippingLayer, width*0.5, height*0.5, w, true, sinInc*a, displayLayer);
  
  }
  else if (m==0) {
    
    float w = width+width*0.5*(cntrlFloat[0]*2-1);
    float h = height/2+((height*0.1)*((cntrlFloat[0]*2-1)+1)/2);
    
    drawImage(clippingLayer, width/2, h, w, true, sinInc*a, displayLayer);
  } 
  
  else if (m==1) {
    
    float w = width*0.7+width*0.3*-(cntrlFloat[0]*2-1);
    float w1 = width*0.3+width*0.15*(cntrlFloat[0]*2-1);
    
    drawImage(clippingLayer, width*0.2, height*0.2, w1, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, width*0.8, height*0.2, w1, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, width*0.2, height*0.8, w1, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, width*0.8, height*0.8, w1, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, width*0.5, height*0.5, w,  true, sinInc*a, displayLayer); 
  } 
  
  else if (m==2) {
    
    float h = height*0.5+height*0.3*(cntrlFloat[0]*2-1);
    float h1 = height*0.5+height*0.3*-(cntrlFloat[0]*2-1);
    
    drawImage(clippingLayer, width*0.25, h, width*0.5, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, width*0.75, h1, width*0.5, false, sinInc*a, displayLayer);
  }
  
  else if (m==3) {
    
    float w = width*0.6+width*0.3*-(cntrlFloat[0]*2-1);
    float w1 = width*0.3+width*0.1*(cntrlFloat[0]*2-1);
    
    drawImage(clippingLayer, width*0.2, height*0.15, w1, false, sinInc*a, displayLayer);
    drawImage(clippingLayer, width*0.2, height*0.5, w1, true, -cosInc*a, displayLayer);
    drawImage(clippingLayer, width*0.2, height*0.85, w1, false, sinInc*a, displayLayer);
    drawImage(clippingLayer, width*0.8, height*0.15, w1, true, cosInc*a, displayLayer);
    drawImage(clippingLayer, width*0.8, height*0.5, w1, false, -sinInc*a, displayLayer);
    drawImage(clippingLayer, width*0.8, height*0.85, w1, true, cosInc*a, displayLayer);
    drawImage(clippingLayer, width*0.5, height*0.5, w, true, 0, displayLayer);
  } 
  
  else if (m==4) {
    
    float w = width*0.6+width*0.3*-(cntrlFloat[0]*2-1);
    float w1 = width*0.3+width*0.1*(cntrlFloat[0]*2-1);
    float off = w1*(inc/TWO_PI);
    
    drawImage(clippingLayer, w1*-1+off, height*0.1, w1, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*0+off, height*0.1, w1, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*1+off, height*0.1, w1, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*2+off, height*0.1, w1, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*3+off, height*0.1, w1, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*4+off, height*0.1, w1, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*5+off, height*0.1, w1, true, sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*0-off, height*0.9, w1, false, -sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*1-off, height*0.9, w1, false, -sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*2-off, height*0.9, w1, false, -sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*3-off, height*0.9, w1, false, -sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*4-off, height*0.9, w1, false, -sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*5-off, height*0.9, w1, false, -sinInc*a, displayLayer);
    drawImage(clippingLayer, w1*6-off, height*0.9, w1, false, -sinInc*a, displayLayer);
    drawImage(clippingLayer, width*0.5, height*0.5, w, true, 0, displayLayer);
  } 
  
  else if (m==5) {
    
    float w = width*0.6+width*0.2*-(cntrlFloat[0]*2-1);
    float w1 = width*0.3+width*0.1*(cntrlFloat[0]*2-1);
    float r=width*0.25;
    int s = 6;
    
    for (int i =0; i<s; i++) {
      
      float x=sin(float(i)/s*TWO_PI-inc)*r;
      float y=cos(float(i)/s*TWO_PI-inc)*r;
      
      drawImage(clippingLayer, width/2+x, height/2+y, w1, true, 0, displayLayer);
    }
    
    drawImage(clippingLayer, width*0.5, height*0.5, w, true, sinInc*a, displayLayer);
  } 
  
  else if (m==6) {
    
    float w = width*0.6+width*0.2*-(cntrlFloat[0]*2-1);
    float w1 = width*0.2+width*0.1*(cntrlFloat[0]*2-1);
    float r= width*0.25;
    int s = 10;
    
    for (int i =0; i<s; i++) {
      
      if (i%2 == 0) r = width*0.25+width*0.3*-sinInc*a;
      else          r = width*0.25+width*0.3*sinInc*a;
      
      float c = float(i)/s*TWO_PI-inc;
      float x =sin(c)*r;
      float y =cos(c)*r;
      
      if (portrait) drawImage(clippingLayer, width/2+x, height/2+y, w1, true, c-PI, displayLayer);
      else          drawImage(clippingLayer, width/2+x, height/2+y, w1, true, -c+PI, displayLayer);
    }
    
    drawImage(clippingLayer, width*0.5, height*0.5, w, true, 0, displayLayer);
    
  }
  
  displayLayer.endDraw();
}

void drawImage(PImage img, float posX, float posY, float sizeX, boolean mirror, float rotation, PGraphics p) {

  /* cette fonction affiche une image dans le calque displayLayer avec 
  un certain nombre de paramètres : position, rotation, effet mirroir */

  float coef = float(clippingLayer.height)/float(clippingLayer.width);
  float sizeY=sizeX*coef;

  if (portrait) {
    sizeX *= 0.6;
    sizeY *= 0.6;
    rotation-= (HALF_PI*rotCam);
  }

  p.pushMatrix();
  p.translate(posX, posY);
  p.rotate(rotation);
  p.scale(-1, 1);
  p.image(img, -sizeX/2, -sizeY/2, sizeX, sizeY);
  p.popMatrix();
}



void postprocessing(){

  /* cette fonction applique les différents effets post processing
  selectionnés par l'utilisateur */
  
  postProcessingLayer.beginDraw();
  postProcessingLayer.clear();
  postProcessingLayer.image(prerenderingLayer, 0, 0, width, height);
  
  if(postprocessing[0]){
    
    motionBlur.set("mode",0);
    postProcessingLayer.filter(motionBlur);
  }
  
  if(postprocessing[1]){
    
    rgbOffset.set("vel",0.3);
    postProcessingLayer.filter(rgbOffset);
  }
  
  if(postprocessing[2]){
    
    fuzz.set("vel",0.3);
    postProcessingLayer.filter(fuzz);
  }
  
  if(postprocessing[3]){
    
    glitch.set("val",0.1);
    postProcessingLayer.filter(glitch);
  }
  
  if(postprocessing[4]){
    
    bloom.set("ray",0.004);
    postProcessingLayer.filter(bloom);
  }
  
  if(postprocessing[5]){
    
    grain.set("opacity",0.05);
    postProcessingLayer.filter(grain);
  }
  
  postProcessingLayer.endDraw();
  
}void jam(float posX, float posY, float size, float rotation) {
  
  pushMatrix();
  imageMode(CENTER);
  translate(posX*width, posY*height);
  rotate(rotation * TWO_PI);
  scale(size, size);
  scale(-1, 1);
  image(clippingLayer, 0, 0);
  imageMode(CORNER);
  popMatrix();

}



void jam( float posX, float posY, float size ) {
  
  jam( posX , posY , size , 0 );
}



void jam() {
  
  jam( 0.5 , 0.5 , 1 , 0 );
} 
