/**************************************************************
 
 ██╗███╗   ██╗████████╗███████╗██████╗  ██████╗ █████╗ ████████╗
 ██║████╗  ██║╚══██╔══╝██╔════╝██╔══██╗██╔════╝██╔══██╗╚══██╔══╝
 ██║██╔██╗ ██║   ██║   █████╗  ██████╔╝██║     ███████║   ██║   
 ██║██║╚██╗██║   ██║   ██╔══╝  ██╔══██╗██║     ██╔══██║   ██║   
 ██║██║ ╚████║   ██║   ███████╗██║  ██║╚██████╗██║  ██║   ██║   
 ╚═╝╚═╝  ╚═══╝   ╚═╝   ╚══════╝╚═╝  ╚═╝ ╚═════╝╚═╝  ╚═╝   ╚═╝   
 
 Dans cette page sont rangées toutes les fonctions permettant
 à l'utilisateur d'interagir avec le programme
 
 ***************************************************************/



int fxSelected = 0;
int rotCam=1;
int lastMouseX;
int lastMouseY;
int[] cntrlInt;
int[] cntrlMax;
boolean[] postprocessing = { false, false, false, false, false, false };
float[] cntrlFloat;
boolean changeCam = false;
boolean mouseIsPressed = false;
boolean mouseClicked = false;
boolean sliderOn = false;
float cursorX ;
float cursorY ;



void initValue() {

  /* cette fonction initialise les valeur relatives aux
   interactions et leur affecte une valeur aléatoire */

  int l = postprocessing.length;
  int[]   cm = {7, 5, listFiles("data/palettes").length, cameras.length};
  int[]   ci = { int(random(0, cm[0])), int(random(0, cm[1])), int(random(0, cm[2])), 0 };
  float[] cf = { random(0, 1), random(0, 1), random(0, 1), random(0, 1) };

  cntrlFloat = cf;
  cntrlInt   = ci;
  cntrlMax   = cm;

  lastMouseX = mouseX;
  lastMouseY = mouseY;

  speed = cntrlFloat[3];

  for (int i =0; i<l; i++) {
    int r = int(random(0, 2));
    if (r==0) postprocessing[i] = true;
    else      postprocessing[i] = false;
  }

  shaderSettings();
  setColor(cntrlInt[2]);
}




void mouseWheel(MouseEvent event) {

  /* cette fonction est lue lorsque le joueur utilise
   la molette de sa souris. La valeur du paramètre sélectionné
   est alors mise à jour. */


  float e = event.getCount();
  float s = 0.002;

  cntrlFloat[fxSelected] = constrain(cntrlFloat[fxSelected] + ( e * s ), 0, 1-s);
  shaderSettings();
  setSpeed(cntrlFloat[3]);
}



void keyPressed() {

  /* cette fonction est lue lorsque le joueur presse une touche
  en fonction de la touche pressé une fonction est appellée */

  boolean b = background[cntrlInt[3]]==null;

  if      (titleScreen) titleScreen = false ;

  else if (b)    capture();

  else if (!hack && !titleScreen && !initMenu) {

    // post processing
    
    if (keyCode==90) postProcessingControl( 0 );
    if (keyCode==88) postProcessingControl( 1 );
    if (keyCode==67) postProcessingControl( 2 );
    if (keyCode==86) postProcessingControl( 3 );
    if (keyCode==66) postProcessingControl( 4 );
    if (keyCode==78) postProcessingControl( 5 );

    // settings
    
    if (keyCode==80) portaitControl();
    if (keyCode==82) randomizeControl();
    if (keyCode==85) UIControl();
    if (keyCode==71) greenControl();
    if (keyCode==79) smoothControl();
    if (keyCode==70) captureControl();

    // (↑,↓) déplace la séléction du paramêtre
    
    if (keyCode==38) fxSelected = constrainLoop(fxSelected, -1, cntrlInt.length);
    if (keyCode==40) fxSelected = constrainLoop(fxSelected, 1, cntrlInt.length);

    // (←,→) modifie la valeurs du paramêtre séléctionné
    
    if (keyCode==37) cntrlInt[fxSelected] = constrainLoop(cntrlInt[fxSelected], -1, cntrlMax[fxSelected]);
    if (keyCode==39) cntrlInt[fxSelected] = constrainLoop(cntrlInt[fxSelected], 1, cntrlMax[fxSelected]);

    // applique les changements de paramètre aux shaders

    if ((keyCode==37 || keyCode==39) && fxSelected==2) setColor(cntrlInt[2]);
    if ((keyCode==37 || keyCode==39) && fxSelected==3) changeCamera(cntrlInt[3]);
  }


  // export

  if (!titleScreen && !initMenu && keyCode==83) {

    if (framePerFrame) {

      recording = true;
      frameExport();
      timePerFrame();
      exportFrameCount++;
    } else recording = !recording;

    if (recording) message = "saving frames to computer";
    else           message = "saving complete";
  }
}



int constrainLoop(int v, int p, int m) {

  /* cette fonction permet d'imposer un seuil minim et 
   maximum aux paramètres modifiés par l'utilisateur */

  return ( v + p + m ) % m;
}   


void setSpeed(float n) {

  speed = n;
} 

void captureControl() {
  
  capture();
  message = "new background captured";
}


void greenControl() {

  greenHSB=!greenHSB;
  if (greenHSB) message = "HSB clipping mode activated";
  else          message = "RVB clipping mode activated";
}

void randomizeControl() {

  initValue();
  message = "randomized";
}


void portaitControl() {

  portrait=!portrait;
  if (portrait) message = "portait mode activated";
  else          message = "landscape mode activated";
} 


void UIControl() {

  UI=!UI;
} 


void smoothControl() {
  
  strongSmooth=(strongSmooth+1)%3;
  if (strongSmooth==0) message = "soften shape set to : light";
  if (strongSmooth==1) message = "soften shape set to : regular";
  if (strongSmooth==2) message = "soften shape set to : bold";
}

void postProcessingControl(int n) {

  String name;

  if      (n==0) name = "motion blur";
  else if (n==1) name = "RGB offset";
  else if (n==2) name = "fuzz";
  else if (n==3) name = "glitch";
  else if (n==4) name = "bloom";
  else           name = "grain";

  postprocessing[n] = !postprocessing[n];
  
  if (postprocessing[n]) message = name+" effect : activated";
  else                   message = name+" effect : disabled";
} 
