/***********************************************************************

  ██╗███╗   ██╗████████╗███████╗██████╗ ███████╗ █████╗  ██████╗███████╗
  ██║████╗  ██║╚══██╔══╝██╔════╝██╔══██╗██╔════╝██╔══██╗██╔════╝██╔════╝
  ██║██╔██╗ ██║   ██║   █████╗  ██████╔╝█████╗  ███████║██║     █████╗  
  ██║██║╚██╗██║   ██║   ██╔══╝  ██╔══██╗██╔══╝  ██╔══██║██║     ██╔══╝  
  ██║██║ ╚████║   ██║   ███████╗██║  ██║██║     ██║  ██║╚██████╗███████╗
  ╚═╝╚═╝  ╚═══╝   ╚═╝   ╚══════╝╚═╝  ╚═╝╚═╝     ╚═╝  ╚═╝ ╚═════╝╚══════╝
    
  Dans cette page sont rangées toutes les fonctions determinant
  l'affichage de l'interface graphique à destination de l'utilisateur

************************************************************************/ 
                      
                                                          

boolean titleScreen = true;
PFont font;
String message =  "welcome aboard captain !";
boolean cursor = false;




void setupMenu() {

  /* cette fonction crée le calque qui s'affiche lorsque le
  programme ne dispose pas de capture d'arrière plan */

  camera.read();
  setUpLayer.beginDraw();
  setUpLayer.textFont(font, 32);
  setUpLayer.image(camera, 0, 0, width, height);
  setUpLayer.textAlign(CENTER, CENTER);
  setUpLayer.textSize(30);
  setUpLayer.fill(colorPalette[0]);
  setUpLayer.stroke(colorPalette[1]);
  setUpLayer.text("press space to set background", width/2, height/2);
  setUpLayer.endDraw();
  
}

void UI() {

  /* cette fonction crée le calque ou s'affichent les parmètres 
  et leurs valeurs, un indacateur visuel pour determiner lequel 
  est selectionné, ainsi que la fréquence d'images par seconde */
  
  cursor=false;

  UILayer.beginDraw();
  UILayer.clear();
  UILayer.fill(colorPalette[1]);
  
  messageUI(0);
  cntrlUI(0);
  postProcessingUI(0);
  
  
  UILayer.filter(blur);
  UILayer.textFont(font);
  messageUI(1);
  cntrlUI(1);
  postProcessingUI(1);
  frameRateUI();
  settingsUI();
  logos();

  UILayer.endDraw();
}



void logos() {

  /* cetonction crée le calque avec les logos qui s'affichent 
  dans le coin droit de l'écran */
  
  PImage[] logos = {
    loadImage("logos/mp.png"),
    loadImage("logos/vm.png")
  };
  
  float offset = width;
  float pad = width * 0.01;
  float l = logos.length;
  
  for (int i = 0; i < l; i++ ) {
    
    float coef = float(logos[i].height)/float(logos[i].width);
    float h = width * 0.05;
    float w = h / coef;
    
    offset -= ( w + pad );
    UILayer.image(logos[i], offset-width * 0.02-pad, height-h-width * 0.02-pad, w, h);
  }
  
}



boolean mouseOver(float x, float y, float w, float h){
  
  boolean b = (mouseX > x && mouseX < (x+w) && mouseY > y && mouseY < y+h);
  if (b) cursor=true;
  return b;

}


float slider( float x,float w) {
  
    return((mouseX-x)/w);
}



void settingsUI(){
  
  
}



void frameRateUI(){
  
  // framerate
  
  UILayer.fill(colorPalette[1]);
  UILayer.textAlign(RIGHT, TOP);
  UILayer.textSize(40);
  UILayer.text(frameRate, width-20, 20);
  UILayer.textAlign(LEFT, TOP);
  UILayer.textSize(20);
  UILayer.text("(F) capture background\n(U) hide user interface\n(S) save frames\n(P) portrait mode\n(G) green screen\n(O) smooth shape\n(R) randomize", 20, 20);
}



void postProcessingUI( int n ){

  // paramètres postprocessing
  
  for (int i=0; i<postprocessing.length; i++) {

    float x = width/2 - 155 + i*50;
    float y = height-60;

    if ( n == 0 ) {
      
      if (postprocessing[i]) UILayer.fill(colorPalette[3]);
      else                   UILayer.fill(colorPalette[0]);
      
      UILayer.strokeWeight(2);
      UILayer.rect(x, y, 40, 40, 4, 4, 4, 4);
    }
    
    if ( n == 1 ) {
      
      String txt;
      
      if (postprocessing[i]) txt = "on";
      else                   txt = "off";
      
      if (postprocessing[i]) UILayer.fill(colorPalette[0]);
      else                   UILayer.fill(colorPalette[2]);
      
      UILayer.textSize(20);
      UILayer.textAlign(CENTER, CENTER);
      UILayer.text(txt, x+20, y+20);
    
      // framerate
  
      String[] boolLabels = { "motion blur (W)" , "RBG offset (X)" , "fuzz (C)" , "glitch (V)" , "bloom (B)" , "grain (N)" };
      
      if (mouseOver(x, y, 40, 40)) {
        label(boolLabels[i]);
        if (mouseClicked) postProcessingControl( i );
      }
    }
  }
}



void cntrlUI(int n) {
  
  for (int i=0; i<cntrlInt.length; i++) {
    
    int y = height-210+50*i;
    float x = cntrlFloat[i]*100;
    
    if ( n == 0 ) {
      UILayer.fill(colorPalette[0]);;
      UILayer.strokeWeight(2);
      UILayer.rect(20, y, 40, 40, 4, 4, 4, 4);
      
      UILayer.fill(colorPalette[0]);
      UILayer.strokeWeight(2);
      UILayer.rect(80, y, 100, 40, 4, 4, 4, 4);
      UILayer.fill(colorPalette[2]);
      if (x > 0.01) {
        UILayer.noStroke();
        if (i==fxSelected) UILayer.fill(colorPalette[3]);
        UILayer.rect(81, y+1, x-2, 38, 3, 3, 3, 3);
      }
      
      if (i==fxSelected) {
        UILayer.fill(colorPalette[3]);
        UILayer.triangle(10, y+20, 15, y+20+4, 15, y+20-4);
        UILayer.triangle(70, y+20, 65, y+20+4, 65, y+20-4);
      }
    }
    
    if ( n == 1 ) {
      
      

  // paramètres décimaux et intérgaux
    
      if (i==fxSelected) UILayer.fill(colorPalette[3]);
      else UILayer.fill(colorPalette[2]);
     
      UILayer.textSize(30);
      UILayer.textAlign(CENTER, CENTER);
      UILayer.text(cntrlInt[i], 40, y+20);
    
      String[] incLabels   = { "display mode (arrows)" , "background (arrows)" , "palette (arrows)" , "camera (arrows)" };
      String[] floatLabels = { "position (mouse wheel)" , "amplitude (mouse wheel)" , "palette length (mouse wheel)" , "speed (mouse wheel)" };
      
      if (mouseOver(20, y, 40 , 40)) {
        label(  incLabels[i] );
        if (mouseClicked) {
          cntrlInt[i] = constrainLoop(cntrlInt[i], 1,cntrlMax[i]);
          fxSelected=i;
          if (i==2) setColor(cntrlInt[2]);
          if (i==3) changeCamera(cntrlInt[3]);
        }
      }
      if (mouseOver(80, y, 100, 40)) {
        label(floatLabels[i]);
        if (mouseClicked) {
          fxSelected = i;
          sliderOn = true;
          slider(x, 100);
        }
      }
      if ( sliderOn && fxSelected == i ){
        cntrlFloat[i] = constrain(slider(80, 100) , 0 , 0.99);
        shaderSettings();
        setSpeed(cntrlFloat[3]);
      }
    }
  }
}



void messageUI(int n) {
    
    float w = width*0.32;
    float x = width/2-w/2;
    
    if( n == 0 ){
      UILayer.fill(colorPalette[0]);
      UILayer.strokeWeight(2);
      UILayer.rect(x, 20, w, 40, 4, 4, 4, 4);
    }
    
    if( n == 1 ){
      UILayer.textSize(16);
      UILayer.textAlign(CENTER, CENTER);
      UILayer.fill(colorPalette[3]);
      UILayer.text(message, x + w/2 , 40);
    }
}



void label(String text) {
  
    float w = text.length()*9.5 + 10;
    
    UILayer.textAlign(CENTER, TOP);
    UILayer.textSize(18);
    UILayer.fill(colorPalette[1]);
    UILayer.noStroke();
    UILayer.strokeWeight(2);
    UILayer.rect(mouseX, mouseY-20,w,20,2,2,2,2);
    UILayer.fill( colorPalette[3] );
    UILayer.text( text , mouseX + ( w / 2 ) , mouseY - 18 );
}


void title() {
  
  PImage img = loadImage("logos/cj.png");
    
  float coef = float(img.height)/float(img.width);
  float h = width / 4;
  float w = h / coef;
  int x = clippingLayer.width/2;
  int y = clippingLayer.height/2;
  clippingLayer.beginDraw();
  clippingLayer.translate(x,y);
  clippingLayer.scale(-1,1);
  clippingLayer.image(img, -w/2 , -h/2 , w , h );
  clippingLayer.endDraw();
  shaderBgSet();
}
